;;; -*- mode: lisp; package: infoman -*-
;;; Last updated: <2005/07/02>

(provide "infoman/defs")

(in-package "infoman")

(defvar *infoman-frame-name* "infoman"
	"t[")

(defvar *infoman-data-folder-path* "~/.infoman"
	"f[^ۑꏊ")

(defvar *infoman-config-file-name* "config.l"
	"infomanݒt@C")

(defvar *infoman-folder-list-file-path* (merge-pathnames "folders" *infoman-data-folder-path*)
	"tH_Xgt@CpX")

(defvar *infoman-data-file-extension* ".dat"
	"f[^t@Cgq")


(defvar *infoman-list-height* (floor (screen-height) 3)
	"XgEBhE")

(defvar *infoman-list-width* (- (screen-width) (floor (screen-width) 6))
	"XgEBhE")


(defvar *infoman-folder-fgcolor* nil
	"tH_F")

(defvar *infoman-folder-bold* nil
	"tH_")

(defvar *infoman-current-folder-bgcolor* 2
	"ItH_}[NF")


(defvar *infoman-list-fgcolor* nil
	"XgF")

(defvar *infoman-list-bold* nil
	"Xg")

(defvar *infoman-list-item* "\\1"
	"Xg\")

(defvar *infoman-list-item-width* nil
	"Xg\ڕ")


(defvar *infoman-header-start-char* ""
	"wb_擪")

(defvar *infoman-header-end-char* " :"
	"wb_")

(defvar *infoman-header-fgcolor* nil
	"wb_F")

(defvar *infoman-header-bgcolor* nil
	"wb_wiF")

(defvar *infoman-header-bold* nil
	"wb_")

(defvar *infoman-view-indent* t
	"wb_ʒuɃCfg")

(defvar *infoman-view-mask* nil
	"}XN\")


(defvar *infoman-filer-directory* nil
	"t@C\fBNg")


(defvar *infoman-buffer-prefix* " *infoman: "
	"obt@擪")

(defvar *infoman-folder-buffer-name* (concat *infoman-buffer-prefix* "Folder*")
	"Folderobt@")

(defvar *infoman-list-buffer-name* (concat *infoman-buffer-prefix* "List*")
	"Listobt@")

(defvar *infoman-view-buffer-name* (concat *infoman-buffer-prefix* "View*")
	"Viewobt@")

(defvar *infoman-data-buffer-name* (concat *infoman-buffer-prefix* "Data*")
	"Data[hobt@")

(defvar *infoman-draft-buffer-name* (concat *infoman-buffer-prefix* "Draft*")
	"Draftobt@")

(defvar *infoman-grep-buffer-name* (concat *infoman-buffer-prefix* "Grep*")
	"Grepobt@")

(defvar *infoman-work-buffer-name* (concat *infoman-buffer-prefix* "Work*")
	"Workobt@")


(defvar *infoman-folder-buffer-flags* (+ *window-flag-line-number*
										 *window-flag-ruler*
										 *window-flag-newline*
										 *window-flag-full-width-space*
										 *window-flag-vscroll-bar*
										 *window-flag-eof*
										 *window-flag-half-width-space*)
	"Folderobt@\tO")

(defvar *infoman-list-buffer-flags* (+ *window-flag-ruler*
									   *window-flag-newline*
									   *window-flag-full-width-space*
									   *window-flag-vscroll-bar*
									   *window-flag-eof*
									   *window-flag-half-width-space*)
	"Listobt@\tO")

(defvar *infoman-view-buffer-flags* (+ *window-flag-line-number*
									   *window-flag-ruler*
									   *window-flag-newline*
									   *window-flag-tab*
									   *window-flag-full-width-space*
									   *window-flag-vscroll-bar*
									   *window-flag-eof*
									   *window-flag-half-width-space*)
	"Viewobt@\tO")


(defvar *infoman-folder-mode-map* nil
	"Folderobt@L[}bv")

(defvar *infoman-list-mode-map* nil
	"Listobt@L[}bv")

(defvar *infoman-view-mode-map* nil
	"Viewobt@L[}bv")

(defvar *infoman-draft-mode-map* nil
	"Draftobt@L[}bv")

(defvar *infoman-grep-mode-map* nil
	"Grepobt@L[}bv")


(defvar *infoman-mode-hook* nil
	"infomanNtbN")

(defvar *infoman-folder-mode-hook* nil
	"Folderobt@쐬tbN")

(defvar *infoman-list-mode-hook* nil
	"Listobt@쐬tbN")

(defvar *infoman-view-mode-hook* nil
	"Viewobt@쐬tbN")

(defvar *infoman-draft-mode-hook* nil
	"Draftobt@쐬tbN")

(defvar *infoman-grep-mode-hook* nil
	"Grepobt@쐬tbN")


(defvar *infoman-folder-list* nil
	"tH_Xg")

(defvar *infoman-data-file-path* nil
	"ݕ\̃f[^t@CpXigqj")

(defvar *infoman-record-regexp* nil
	"R[hK\")

(defvar *infoman-list-item-header* nil
	"XgACewb_")

(defvar *infoman-list-item-value* nil
	"XgACe")

(defvar *infoman-list-value-tmp1* nil
	"XgACeev1")

(defvar *infoman-list-value-tmp2* nil
	"XgACeev2")

(defvar *infoman-list-item-point* nil
	"XgACeʒu")

(defvar *infoman-list-item-line* nil
	"XgACes")

(defvar *infoman-grep-search-string* nil
	"Grep")

(defvar *infoman-grep-record-line* nil
	"GrepR[hCio[Xg")

(defvar *infoman-completion-list* nil
	"⊮Xg")

(defvar *infoman-password-length* 8
	"ftHg̃pX[h")

(defvar *infoman-password-string* "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890"
	"ftHg̃pX[h\镶")

(defvar *infoman-message-p* t
	"mF_CAO\")


(defun infoman-previous-page ()
	"Oy[Wor2s"
	(interactive)
	(unless (previous-page)
		(previous-virtual-line 2)))

(defun infoman-next-page ()
	"y[Wor2s"
	(interactive)
	(unless (next-page)
		(next-virtual-line 2)))

(defun infoman-exit ()
	"infomanI"
	(interactive)
	(let ((frame
		   (find-pseudo-frame *infoman-frame-name*))
		  bufname)
		(dolist (var (buffer-list))
			(setf bufname (buffer-name var))
			(when (string-match *infoman-buffer-prefix* bufname)
				(delete-buffer bufname)))
		(when frame
			(delete-pseudo-frame frame))))

(defun infoman-previous-virtual-line ()
	"O̍sorobt@"
	(interactive)
	(unless (previous-virtual-line)
		(goto-line (buffer-lines))))

(defun infoman-next-virtual-line ()
	"̍sorobt@擪"
	(interactive)
	(unless (next-virtual-line)
		(goto-line 1)))
