;;; -*- mode: lisp; package: infoman -*-
;;; Last updated: <2005/07/08>

(eval-when (:compile-toplevel :load-toplevel :execute)
	(unless (find-package "infoman")
		(defpackage "infoman"
			(:use "lisp" "editor")
			(:nicknames "im"))))

(require "infoman/defs")
(require "infoman/list")
(require "infoman/folder")
(require "infoman/draft")
(require "infoman/grep")
(require "infoman/view")
(require "infoman/keymap")

(provide "infoman/infoman")

(in-package "infoman")

(defun infoman-close ()
	"EBhE"
	(interactive)
	(erase-buffer (selected-buffer))
	(if (string= (buffer-name (selected-buffer)) *infoman-list-buffer-name*)
			(progn
				(infoman-view-window-reset)
				(when (find-buffer *infoman-data-buffer-name*)
					(delete-buffer *infoman-data-buffer-name*))
				(setf *infoman-list-item-header* nil *infoman-record-regexp* nil)
				(other-window)
				(delete-text-attributes 'current-folder))
		(other-window)))

(defun infoman-init ()
	"infomanݒ"
	(let* ((l (merge-pathnames *infoman-config-file-name* *infoman-data-folder-path*))
		   (lc (concat l "c")))
		(when (file-exist-p l)
			(if (file-newer-than-file-p lc l)
					(load lc)
				(load l)))))

(defun user::infoman ()
	"infomanN"
	(interactive)
	(if (find-pseudo-frame *infoman-frame-name*)
			(if (eq (message-box "infoman EBhEĔzu܂H"
								 *infoman-frame-name*
								 '(:yes-no :question :button2))
					:yes)
					(progn
						(select-pseudo-frame (find-pseudo-frame *infoman-frame-name*))
						(if (find-buffer *infoman-view-buffer-name*)
								(erase-buffer (find-buffer *infoman-view-buffer-name*))))
				(error "~A͂łɑ݂܂" *infoman-frame-name*))
		(new-pseudo-frame *infoman-frame-name*))
	(delete-other-windows)
	(infoman-init)
	(infoman-list-mode)
	(when (or (> *infoman-list-height* (window-height))
			  (> *infoman-list-width* (window-width)))
		(setf *infoman-list-height* (floor (screen-height) 3))
		(setf *infoman-list-width* (- (screen-width) (floor (screen-width) 6))))
	(split-window *infoman-list-height*)
	(split-window-vertically *infoman-list-width*)
	(other-window)
	(infoman-folder-mode)
	(infoman-show-folders)
	(other-window)
	(infoman-view-mode)
	(other-window -1)
	(toggle-ime nil)
	(run-hooks '*infoman-mode-hook*))
