;;; -*- mode: lisp; package: infoman -*-
;;; Last updated: <2005/07/08>

(provide "infoman/keymap")

(in-package "infoman")

(defun infoman-mouse-left-press ()
	"}EX{^"
	(interactive)
	(let ((click (mod *last-mouse-click-count* 6)))
		(case click
			(1
			 (mouse-left-press))
			(2
			 (case buffer-mode
				 ('infoman-list-mode (infoman-open-list2))
				 ('infoman-folder-mode (infoman-open-folder))
				 ('infoman-view-mode (infoman-copy-to-clipboard-current-item))
				 ('infoman-grep-mode (infoman-grep-open-list2)))))))

(unless (or *infoman-grep-mode-map*
			*infoman-draft-mode-map*
			*infoman-view-mode-map*
			*infoman-folder-mode-map*
			*infoman-list-mode-map*)
	(setf *infoman-grep-mode-map* (make-sparse-keymap))
	(setf *infoman-draft-mode-map* (make-sparse-keymap))
	(setf *infoman-view-mode-map* (make-sparse-keymap))
	(setf *infoman-folder-mode-map* (make-sparse-keymap))
	(setf *infoman-list-mode-map* (make-sparse-keymap))
	(dolist (map (list *infoman-grep-mode-map*
					   *infoman-view-mode-map*
					   *infoman-folder-mode-map*
					   *infoman-list-mode-map*))
		(define-key map #\b 'backward-char)
		(define-key map #\f 'forward-char)
		(define-key map #\n 'infoman-next-virtual-line)
		(define-key map #\p 'infoman-previous-virtual-line)
		(define-key map #\Q 'infoman-exit)
		(define-key map #\v 'infoman-next-page)
		(define-key map #\z 'infoman-previous-page))
	(define-key *infoman-folder-mode-map* #\LBtnDown 'infoman-mouse-left-press)
	(define-key *infoman-folder-mode-map* #\RET 'infoman-open-folder)
	(define-key *infoman-folder-mode-map* #\a 'infoman-add-folder)
	(define-key *infoman-folder-mode-map* #\d 'infoman-delete-folder)
	(define-key *infoman-folder-mode-map* #\C-M-n 'infoman-folder-line-down)
	(define-key *infoman-folder-mode-map* #\C-M-p 'infoman-folder-line-up)
	(define-key *infoman-folder-mode-map* #\r 'infoman-rename-folder)
	(define-key *infoman-list-mode-map* #\LBtnDown 'infoman-mouse-left-press)
	(define-key *infoman-list-mode-map* #\RET 'infoman-open-list)
	(define-key *infoman-list-mode-map* #\TAB 'infoman-open-list2)
	(define-key *infoman-list-mode-map* #\a 'infoman-add-list)
	(define-key *infoman-list-mode-map* #\d 'infoman-delete-list)
	(define-key *infoman-list-mode-map* #\g 'infoman-grep)
	(define-key *infoman-list-mode-map* #\G 'infoman-grep-header)
	(define-key *infoman-list-mode-map* #\N 'infoman-open-next-list)
	(define-key *infoman-list-mode-map* #\C-M-n 'infoman-list-line-down)
	(define-key *infoman-list-mode-map* #\P 'infoman-open-previous-list)
	(define-key *infoman-list-mode-map* #\C-M-p 'infoman-list-line-up)
	(define-key *infoman-list-mode-map* #\q 'infoman-close)
	(define-key *infoman-view-mode-map* #\LBtnDown 'infoman-mouse-left-press)
	(define-key *infoman-view-mode-map* #\RET 'infoman-edit-item)
	(define-key *infoman-view-mode-map* #\F11 'infoman-next-error)
	(define-key *infoman-view-mode-map* #\0 'infoman-copy-to-clipboard-current-item)
	(define-key *infoman-view-mode-map* #\1 'infoman-copy-to-clipboard1)
	(define-key *infoman-view-mode-map* #\M-1 'infoman-goto-item1)
	(define-key *infoman-view-mode-map* #\2 'infoman-copy-to-clipboard2)
	(define-key *infoman-view-mode-map* #\M-2 'infoman-goto-item2)
	(define-key *infoman-view-mode-map* #\3 'infoman-copy-to-clipboard3)
	(define-key *infoman-view-mode-map* #\M-3 'infoman-goto-item3)
	(define-key *infoman-view-mode-map* #\4 'infoman-copy-to-clipboard4)
	(define-key *infoman-view-mode-map* #\M-4 'infoman-goto-item4)
	(define-key *infoman-view-mode-map* #\5 'infoman-copy-to-clipboard5)
	(define-key *infoman-view-mode-map* #\M-5 'infoman-goto-item5)
	(define-key *infoman-view-mode-map* #\6 'infoman-copy-to-clipboard6)
	(define-key *infoman-view-mode-map* #\M-6 'infoman-goto-item6)
	(define-key *infoman-view-mode-map* #\7 'infoman-copy-to-clipboard7)
	(define-key *infoman-view-mode-map* #\M-7 'infoman-goto-item7)
	(define-key *infoman-view-mode-map* #\8 'infoman-copy-to-clipboard8)
	(define-key *infoman-view-mode-map* #\M-8 'infoman-goto-item8)
	(define-key *infoman-view-mode-map* #\9 'infoman-copy-to-clipboard9)
	(define-key *infoman-view-mode-map* #\M-9 'infoman-goto-item9)
	(define-key *infoman-view-mode-map* #\a 'infoman-add-header)
	(define-key *infoman-view-mode-map* #\d 'infoman-delete-header)
	(define-key *infoman-view-mode-map* #\N 'infoman-view-next-list)
	(define-key *infoman-view-mode-map* #\C-n 'infoman-goto-next-item)
	(define-key *infoman-view-mode-map* #\C-M-n 'infoman-item-line-down)
	(define-key *infoman-view-mode-map* #\P 'infoman-view-previous-list)
	(define-key *infoman-view-mode-map* #\C-p 'infoman-goto-previous-item)
	(define-key *infoman-view-mode-map* #\C-M-p 'infoman-item-line-up)
	(define-key *infoman-view-mode-map* #\q 'infoman-close)
	(define-key *infoman-view-mode-map* #\r 'infoman-rename-header)
	(define-key *infoman-draft-mode-map* #\M-. 'infoman-popup-completion)
	(define-key *infoman-draft-mode-map* '(#\C-c #\f) 'infoman-insert-filepath)
	(define-key *infoman-draft-mode-map* '(#\C-c #\p) 'infoman-insert-password)
	(define-key *infoman-draft-mode-map* '(#\C-x #\k) 'infoman-delete-draft)
	(define-key *infoman-draft-mode-map* '(#\C-x #\C-k) 'infoman-delete-draft)
	(define-key *infoman-draft-mode-map* '(#\C-x #\s) 'infoman-save-draft)
	(define-key *infoman-draft-mode-map* '(#\C-x #\C-s) 'infoman-save-draft)
	(define-key *infoman-grep-mode-map* #\LBtnDown 'infoman-mouse-left-press)
	(define-key *infoman-grep-mode-map* #\RET 'infoman-grep-open-list)
	(define-key *infoman-grep-mode-map* #\TAB 'infoman-grep-open-list2)
	(define-key *infoman-grep-mode-map* #\F10 'infoman-grep-first-error)
	(define-key *infoman-grep-mode-map* #\N 'infoman-grep-open-next-list)
	(define-key *infoman-grep-mode-map* #\P 'infoman-grep-open-previous-list)
	(define-key *infoman-grep-mode-map* #\q 'infoman-grep-close))
