;;; -*- mode: lisp; package: infoman -*-
;;; Last updated: <2005/07/08>

(provide "infoman/list")

(in-package "infoman")

(defun infoman-view-window-reset ()
	"ViewEBhEZbg"
	(when (find-buffer *infoman-draft-buffer-name*)
		(other-window -1)
		(set-buffer (find-buffer *infoman-draft-buffer-name*))
		(infoman-delete-draft)
		(erase-buffer (selected-buffer))
		(other-window)))

(defun infoman-transpose-line (lnum updown)
	"Lbgs㉺Ɉړ"
	(goto-line lnum)
	(let ((beg (point))
		  (end (progn
				   (goto-eol)
				   (point))))
		(insert (prog1
						(buffer-substring beg end)
					(delete-region beg end)
					(case updown
						(1 (delete-char)
						   (if (forward-line)
								   (open-line)
							   (progn
								   (goto-eol)
								   (newline))))
						(-1 (delete-char -1)
							(goto-bol)
							(open-line)))))))

(defun infoman-list-line-up ()
	"ݍs̃Xgֈړ"
	(interactive)
	(let ((lnum (current-line-number)))
		(unless (or (eobp)
					(= (current-line-number) 1))
			(infoman-view-window-reset)
			(set-buffer (find-buffer *infoman-data-buffer-name*))
			(infoman-transpose-line (1+ lnum) -1)
			(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
			(set-buffer-modified-p nil)
			(set-buffer (find-buffer *infoman-list-buffer-name*))
			(setf buffer-read-only nil)
			(infoman-transpose-line lnum -1)
			(write-file *infoman-data-file-path*)
			(set-buffer-modified-p nil)
			(setf buffer-read-only t)
			(goto-line (1- lnum)))))

(defun infoman-list-line-down ()
	"ݍs̃Xgֈړ"
	(interactive)
	(let ((lnum (current-line-number)))
		(unless (or (eobp)
					(= lnum (1- (buffer-lines))))
			(infoman-view-window-reset)
			(set-buffer (find-buffer *infoman-data-buffer-name*))
			(infoman-transpose-line (1+ lnum) 1)
			(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
			(set-buffer-modified-p nil)
			(set-buffer (find-buffer *infoman-list-buffer-name*))
			(setf buffer-read-only nil)
			(infoman-transpose-line lnum 1)
			(write-file *infoman-data-file-path*)
			(set-buffer-modified-p nil)
			(setf buffer-read-only t)
			(goto-line (1+ lnum)))))

(defun infoman-delete-list ()
	"Xg폜"
	(interactive)
	(when (and (not (eobp))
			   (eq (message-box "ݍs̃ACeXg폜܂H"
								*infoman-frame-name*
								'(:yes-no :exclamation :button2))
				   :yes))
		(let ((lnum (1+ (current-line-number))))
			(infoman-view-window-reset)
			(set-buffer (find-buffer *infoman-data-buffer-name*))
			(goto-line lnum)
			(delete-region (point)
						   (progn
							   (or (forward-line)
								   (goto-eol))
							   (point)))
			(when (eobp)
				(delete-char -1))
			(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
			(set-buffer-modified-p nil)
			(set-buffer (find-buffer *infoman-list-buffer-name*))
			(setf buffer-read-only nil)
			(delete-region (progn
							   (goto-bol)
							   (point))
						   (progn
							   (forward-line)
							   (point)))
			(write-file *infoman-data-file-path*)
			(set-buffer-modified-p nil)
			(setf buffer-read-only t))))

(defun infoman-calc-length (str)
	"Sp2Ƃ镶񒷂߂"
	(let ((width (length str)))
		(dotimes (var width width)
			(if (kanji-char-p (char str var))
					(incf width)))))

(defun infoman-max-header-width ()
	"wb_̍ő啝߂"
	(let (width
		  (max-width 0))
		(dolist (var *infoman-list-item-header* max-width)
			(setf width (infoman-calc-length var))
			(when (< max-width width)
				(setf max-width width)))))

(defun infoman-view-list ()
	"Xg{"
	(if (string-equal *infoman-view-buffer-name*
						(buffer-name (selected-buffer)))
		(let* ((max-width (infoman-max-header-width))
			   (item-num 0)
			   (n (+ (infoman-calc-length *infoman-header-start-char*)
					 max-width
					 (infoman-calc-length *infoman-header-end-char*)
					 1)))
			(setf *infoman-list-item-point* nil *infoman-list-item-line* nil)
			(setf buffer-read-only nil)
			(erase-buffer (selected-buffer))
			(dolist (var *infoman-list-item-header*)
				(insert "\n")
				(set-text-attribute (point)
									(progn
										(insert *infoman-header-start-char*)
										(insert var)
										(insert " " (- max-width (infoman-calc-length var)))
										(insert *infoman-header-end-char*)
										(point))
									'header
									:foreground *infoman-header-fgcolor*
									:background *infoman-header-bgcolor*
									:bold *infoman-header-bold*)
				(insert " ")
				(push (point) *infoman-list-item-point*)
				(push (current-line-number) *infoman-list-item-line*)
				(if (and (nth item-num *infoman-view-mask*)
						 (string-not-equal (nth item-num *infoman-list-item-value*) " "))
						(insert "********")
					(if *infoman-view-indent*
							(insert (infoman-view-replace-string (nth item-num *infoman-list-item-value*) n))
						(insert (infoman-view-replace-string (nth item-num *infoman-list-item-value*)))))
				(insert "\n")
				(incf item-num))
			(goto-line 1)
			(set-buffer-modified-p nil)
			(setf buffer-read-only t))))

(defun infoman-add-list ()
	"Xgǉ"
	(interactive)
	(if (and (find-buffer *infoman-data-buffer-name*)
			 (if *infoman-message-p*
					 (eq (message-box "Xgǉ܂H"
									  *infoman-frame-name*
									  '(:yes-no :question :button2))
						 :yes)
				 t))
			(let ((lnum (current-line-number)))
				(infoman-view-window-reset)
				(setf buffer-read-only nil)
				(goto-bol)
				(open-line)
				(insert " ")
				(write-file *infoman-data-file-path* t)
				(set-buffer-modified-p nil)
				(setf buffer-read-only t)
				(set-buffer (find-buffer *infoman-data-buffer-name*))
				(goto-line lnum)
				(goto-eol)
				(insert "\n ")
				(dotimes (var (1- (list-length *infoman-list-item-header*)))
					(insert "\t "))
				(setf *infoman-list-item-value*
					  (split-string (buffer-substring (progn
														  (goto-bol)
														  (point))
													  (progn
														  (goto-eol)
														  (point)))
									#\TAB))
				(goto-bol)
				(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
				(set-buffer-modified-p nil)
				(set-buffer (find-buffer *infoman-list-buffer-name*))
				(other-window -1)
				(infoman-view-list))))

(defun infoman-open-list ()
	"XgI[v"
	(interactive)
	(unless (eobp)
		(let ((lnum (1+ (current-line-number))))
			(infoman-view-window-reset)
			(set-mark-command)
			(set-buffer (find-buffer *infoman-data-buffer-name*))
			(goto-line lnum)
			(setf *infoman-list-item-value*
				  (split-string (buffer-substring (point)
												  (progn
													  (goto-eol)
													  (point)))
								#\TAB))
			(goto-bol)
			(set-buffer (find-buffer *infoman-list-buffer-name*))
			(other-window -1)
			(infoman-view-list))))

(defun infoman-open-previous-list ()
	"EBhEړÕXgI[v"
	(interactive)
	(unless (= (current-line-number) 1)
		(infoman-view-window-reset)
		(next-line -1)
		(infoman-open-list)
		(other-window)))

(defun infoman-open-next-list ()
	"EBhEړ̃XgI[v"
	(interactive)
	(unless (or (eobp)
				(= (current-line-number) (1- (buffer-lines))))
		(infoman-view-window-reset)
		(next-line)
		(infoman-open-list)
		(other-window)))

(defun infoman-open-list2 ()
	"EBhEړXgI[v"
	(interactive)
	(unless (eobp)
		(infoman-open-list)
		(other-window)))

(defun infoman-list-mode ()
	"Xgobt@쐬"
	(set-buffer (get-buffer-create *infoman-list-buffer-name*))
	(kill-all-local-variables)
	(setf mode-name "List")
	(setf buffer-mode 'infoman-list-mode)
	(use-keymap *infoman-list-mode-map*)
	(make-local-variable 'mode-line-format)
	(setf mode-line-format "%M")
	(make-local-variable 'kept-undo-information)
	(setf kept-undo-information nil)
	(make-local-variable 'need-not-save)
	(setf need-not-save t)
	(make-local-variable 'auto-save)
	(setf auto-save nil)
	(set-buffer-fold-type-none)
	(set-local-window-flags (selected-buffer) *infoman-list-buffer-flags* nil)
	(setf buffer-read-only t)
	(run-hooks '*infoman-list-mode-hook*))
