;;; -*- mode: lisp; package: user -*-
;;; Last updated: <2005/07/08>

(defconstant *INFOMAN-ROOT* "~/site-lisp/infoman")

(defconstant *INFOMAN-FILE-LIST* '("infoman.l"
								   "defs.l"
								   "list.l"
								   "folder.l"
								   "view.l"
								   "draft.l"
								   "grep.l"
								   "keymap.l"))

(defun infoman-make-clean ()
	(interactive)
	(let ((path (merge-pathnames *INFOMAN-ROOT* (si:system-root)))
		  (curdir (default-directory)))
		(set-default-directory path)
		(dolist (var (directory path))
			(when (or (string-match "\.lc" var)
					  (string-match "xtags" (string-downcase var)))
				(delete-file var)))
		(set-default-directory curdir)
		(message "infoman-make-clean ... done")))

(defun infoman-make-tags-file ()
	(interactive)
	(let ((path (merge-pathnames *INFOMAN-ROOT* (si:system-root)))
		  (curdir (default-directory)))
		(set-default-directory path)
		(make-tags-file path)
		(set-default-directory curdir)))

(defun infoman-make ()
	(interactive)
	(let ((path (merge-pathnames *INFOMAN-ROOT* (si:system-root))))
		(dolist (var *INFOMAN-FILE-LIST*)
			(byte-compile-file (merge-pathnames var path)))))

(defun infoman-make-all ()
	(interactive)
	(infoman-make)
	(infoman-make-tags-file))
