;;; -*- mode: lisp; package: infoman -*-
;;; Last updated: <2005/07/08>

(provide "infoman/view")

(in-package "infoman")

(defun infoman-next-error ()
	"Grep𔽓]\"
	(interactive)
	(if (and (/= (buffer-lines) 1)
			 *infoman-grep-search-string*
			 (string-not-equal *infoman-grep-search-string* ""))
			(if (scan-buffer *infoman-grep-search-string* :no-dup t :regexp t)
					(start-selection 2 t (match-end 0))
				(if (infoman-view-next-list)
						(if (scan-buffer *infoman-grep-search-string* :regexp t)
								(start-selection 2 t (match-end 0))
							(progn
								(infoman-view-previous-list)
								(message "܂ \"~A\"" *infoman-grep-search-string*)))
					(message "Xgł")))
		(message "GrepȂĂ")))

(defun infoman-copy-to-clipboard (item-num)
	"ڂNbv{[hɃRs["
	(let ((str (nth item-num *infoman-list-item-value*)))
		(when (and (/= (buffer-lines) 1)
				   str)
			(copy-to-clipboard (infoman-view-replace-string str))
			(message "Copy \"~A\" to clipboard" (nth item-num *infoman-list-item-header*)))))

(defun infoman-copy-to-clipboard-current-item ()
	"Lbgs̍ڂNbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard (infoman-get-position)))

(defun infoman-copy-to-clipboard1 ()
	"1Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 0))

(defun infoman-copy-to-clipboard2 ()
	"2Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 1))

(defun infoman-copy-to-clipboard3 ()
	"3Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 2))

(defun infoman-copy-to-clipboard4 ()
	"4Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 3))

(defun infoman-copy-to-clipboard5 ()
	"5Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 4))

(defun infoman-copy-to-clipboard6 ()
	"6Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 5))

(defun infoman-copy-to-clipboard7 ()
	"7Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 6))

(defun infoman-copy-to-clipboard8 ()
	"8Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 7))

(defun infoman-copy-to-clipboard9 ()
	"9Nbv{[hɃRs["
	(interactive)
	(infoman-copy-to-clipboard 8))

(defun infoman-goto-item (item-num)
	"ڂֈړ"
	(let ((len (list-length *infoman-list-item-point*)))
		(when (and (/= (buffer-lines) 1)
				   (> len item-num))
			(goto-char (nth (- len (1+ item-num)) *infoman-list-item-point*)))))

(defun infoman-view-previous-list ()
	"ÕXg{"
	(interactive)
	(unless (= (buffer-lines) 1)
		(let ((item-num (infoman-get-position)))
			(other-window)
			(if (next-line -1)
					(if (string= (buffer-name (selected-buffer)) *infoman-list-buffer-name*)
							(progn
								(infoman-open-list)
								(infoman-goto-item item-num))
						(progn
							(infoman-grep-open-list)
							(infoman-goto-item item-num)))
				(other-window -1)))))

(defun infoman-view-next-list ()
	"̃Xg{"
	(interactive)
	(unless (= (buffer-lines) 1)
		(let ((item-num (infoman-get-position)))
			(other-window)
			(next-line)
			(if (eobp)
					(progn
						(next-line -1)
						(other-window -1)
						nil)
				(if (string= (buffer-name (selected-buffer)) *infoman-list-buffer-name*)
						(progn
							(infoman-open-list)
							(infoman-goto-item item-num))
					(progn
						(infoman-grep-open-list)
						(infoman-goto-item item-num)))))))

(defun infoman-item-line-updown-write-data (updown item-num item-max-num)
	"R[h"
	(let ((record-tmp (split-string (buffer-substring (progn
														  (goto-bol)
														  (point))
													  (progn
														  (goto-eol)
														  (point)))
									#\TAB)))
		(goto-bol)
		(delete-region (point)
					   (progn
						   (goto-eol)
						   (point)))
		(case updown
			(1 (dotimes (var item-num)
				   (insert (nth var record-tmp) "\t"))
			   (insert (nth (1+ item-num) record-tmp) "\t" (nth item-num record-tmp))
			   (dolist (var (last record-tmp (- item-max-num item-num 2)))
				   (insert "\t" var)))
			(-1 (dotimes (var (1- item-num))
					(insert (nth var record-tmp) "\t"))
				(insert (nth item-num record-tmp) "\t" (nth (1- item-num) record-tmp))
				(dolist (var (last record-tmp (- item-max-num item-num 1)))
					(insert "\t" var))))))

(defun infoman-get-position ()
	"Lbgʒu̍ڔԍ𓾂"
	(let ((item-num (1- (list-length *infoman-list-item-line*))))
		(dolist (var *infoman-list-item-line*)
			(when (< (current-line-number) var)
				(decf item-num)))
		(when (= item-num -1)
			(incf item-num))
		item-num))

(defun infoman-item-line-up ()
	"ݍs̍ڂɈړ"
	(interactive)
	(let ((item-num (infoman-get-position))
		  (item-max-num (list-length *infoman-list-item-line*))
		  lnum)
		(unless (or (= item-num 0)
					(= (buffer-lines) 1))
			(long-operation
				(message "start...")
				(set-buffer (find-buffer *infoman-data-buffer-name*))
				(goto-line 1)
				(infoman-item-line-updown-write-data -1 item-num item-max-num)
				(while (next-line)
					(infoman-item-line-updown-write-data -1 item-num item-max-num))
				(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
				(set-buffer (find-buffer *infoman-view-buffer-name*))
				(other-window)
				(setf lnum (current-line-number))
				(setf *infoman-list-item-header* nil *infoman-record-regexp* nil)
				(infoman-get-list *infoman-data-file-path* t)
				(goto-line lnum)
				(infoman-open-list)
				(infoman-goto-item (1- item-num))
				(message "done")))))

(defun infoman-item-line-down ()
	"ݍs̍ڂɈړ"
	(interactive)
	(let ((item-num (infoman-get-position))
		  (item-max-num (list-length *infoman-list-item-line*))
		  lnum)
		(unless (or (= item-num (1- item-max-num))
					(= (buffer-lines) 1))
			(long-operation
				(message "start...")
				(set-buffer (find-buffer *infoman-data-buffer-name*))
				(goto-line 1)
				(infoman-item-line-updown-write-data 1 item-num item-max-num)
				(while (next-line)
					(infoman-item-line-updown-write-data 1 item-num item-max-num))
				(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
				(set-buffer (find-buffer *infoman-view-buffer-name*))
				(other-window)
				(setf lnum (current-line-number))
				(setf *infoman-list-item-header* nil *infoman-record-regexp* nil)
				(infoman-get-list *infoman-data-file-path* t)
				(goto-line lnum)
				(infoman-open-list)
				(infoman-goto-item (1+ item-num))
				(message "done")))))

(defun infoman-rename-header ()
	"ݍs̃wb_l["
	(interactive)
	(if (and (/= (buffer-lines) 1)
			 (if *infoman-message-p*
					 (eq (message-box (format nil
											  "~A l[܂H"
											  (nth (infoman-get-position) *infoman-list-item-header*))
									  *infoman-frame-name*
									  '(:yes-no :question :button2))
						 :yes)
				 t))
			(let ((hname (read-string "Header Name: "))
				  (list-len (list-length *infoman-list-item-header*))
				  (item-num (infoman-get-position))
				  lnum)
				(unless (string-equal hname "")
					(set-buffer (find-buffer *infoman-data-buffer-name*))
					(setf lnum (current-line-number))
					(delete-region (progn
									   (goto-line 1)
									   (point))
								   (progn
									   (goto-eol)
									   (point)))
					(dolist (var (butlast *infoman-list-item-header* (- list-len item-num)))
						(insert var "\t"))
					(insert hname "\t")
					(dolist (var (last *infoman-list-item-header* (- list-len item-num 1)))
						(insert var "\t"))
					(delete-char -1)
					(setf *infoman-list-item-header*
						  (split-string
						   (buffer-substring (progn
												 (goto-bol)
												 (point))
											 (progn
												 (goto-eol)
												 (point)))
						   #\TAB))
					(goto-line lnum)
					(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
					(set-buffer (find-buffer *infoman-view-buffer-name*))
					(infoman-view-list)
					(infoman-goto-item item-num)))))

(defun infoman-delete-header ()
	"wb_폜"
	(interactive)
	(when (and (/= (buffer-lines) 1)
			   (eq (message-box (format nil
										"~A 폜܂H"
										(nth (infoman-get-position) *infoman-list-item-header*))
								*infoman-frame-name*
								'(:yes-no :exclamation :button2))
				   :yes))
		(long-operation
			(message "start...")
			(let* ((header-max-num (list-length *infoman-list-item-line*))
				   (header-num (infoman-get-position))
				   (header-tmp1 (butlast *infoman-list-item-header* (- header-max-num header-num)))
				   (header-tmp2 (last *infoman-list-item-header* (- header-max-num header-num 1)))
				   pos
				   lnum)
				(unless (= header-max-num 1)
					(set-buffer (find-buffer *infoman-data-buffer-name*))
					(goto-line 1)
					(delete-region (point)
								   (progn
									   (goto-eol)
									   (point)))
					(dolist (var header-tmp1)
						(insert var "\t"))
					(dolist (var header-tmp2)
						(insert var "\t"))
					(delete-char -1)
					(if (= header-num 0)
							(while (next-line)
								(goto-bol)
								(setf pos (point))
								(search-forward "\t")
								(forward-char)
								(kill-region pos (point)))
						(if (= header-num (1- header-max-num))
								(while (next-line)
									(goto-eol)
									(search-backward "\t")
									(delete-region (point) (progn
															   (goto-eol)
															   (point))))
							(while (next-line)
								(goto-bol)
								(dotimes (var header-num)
									(scan-buffer "\t" :no-dup t))
								(setf pos (point))
								(scan-buffer "\t" :no-dup t)
								(kill-region pos (point)))))
					(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
					(set-buffer (find-buffer *infoman-view-buffer-name*))
					(other-window)
					(setf lnum (current-line-number))
					(setf *infoman-list-item-header* nil *infoman-record-regexp* nil)
					(infoman-get-list *infoman-data-file-path* t)
					(goto-line lnum)
					(infoman-open-list)
					(infoman-goto-item header-num)))
			(message "done"))))

(defun infoman-add-header ()
	"wb_ǉ"
	(interactive)
	(unless (= (buffer-lines) 1)
		(let* ((header-name (read-string "Header Name: "))
			   (header-max-num (list-length *infoman-list-item-header*))
			   (header-num (if (bobp)
								   0
							   (1+ (infoman-get-position))))
			   (header-tmp1 (butlast *infoman-list-item-header* (- header-max-num header-num)))
			   (header-tmp2 (last *infoman-list-item-header* (- header-max-num header-num)))
			   lnum)
			(unless (string-equal header-name "")
				(long-operation
					(message "start...")
					(set-buffer (find-buffer *infoman-data-buffer-name*))
					(goto-line 1)
					(delete-region (point)
								   (progn
									   (goto-eol)
									   (point)))
					(dolist (var header-tmp1)
						(insert var "\t"))
					(insert (substitute-string header-name "\t" "  "))
					(dolist (var header-tmp2)
						(insert "\t" var))
					(if (= header-num 0)
							(while (next-line)
								(goto-bol)
								(insert " \t"))
						(if (= header-num header-max-num)
								(while (next-line)
									(goto-eol)
									(insert "\t "))
							(while (next-line)
								(goto-bol)
								(dotimes (var header-num)
									(scan-buffer "\t" :no-dup t))
								(insert "\t "))))
					(write-file (concat *infoman-data-file-path* *infoman-data-file-extension*))
					(set-buffer (find-buffer *infoman-view-buffer-name*))
					(other-window)
					(setf lnum (current-line-number))
					(setf *infoman-list-item-header* nil *infoman-record-regexp* nil)
					(infoman-get-list *infoman-data-file-path* t)
					(goto-line lnum)
					(infoman-open-list)
					(infoman-goto-item header-num)
					(message "done"))))))

(defun infoman-goto-item1 ()
	"1ֈړ"
	(interactive)
	(infoman-goto-item 0))

(defun infoman-goto-item2 ()
	"2ֈړ"
	(interactive)
	(infoman-goto-item 1))

(defun infoman-goto-item3 ()
	"3ֈړ"
	(interactive)
	(infoman-goto-item 2))

(defun infoman-goto-item4 ()
	"4ֈړ"
	(interactive)
	(infoman-goto-item 3))

(defun infoman-goto-item5 ()
	"5ֈړ"
	(interactive)
	(infoman-goto-item 4))

(defun infoman-goto-item6 ()
	"6ֈړ"
	(interactive)
	(infoman-goto-item 5))

(defun infoman-goto-item7 ()
	"7ֈړ"
	(interactive)
	(infoman-goto-item 6))

(defun infoman-goto-item8 ()
	"8ֈړ"
	(interactive)
	(infoman-goto-item 7))

(defun infoman-goto-item9 ()
	"9ֈړ"
	(interactive)
	(infoman-goto-item 8))

(defun infoman-goto-previous-item ()
	"Oڂֈړ"
	(interactive)
	(unless (or (= (buffer-lines) 1)
				(<= (point) (car (last *infoman-list-item-point*))))
		(let ((current-pos (point))
			  (n 0))
			(dolist (var *infoman-list-item-point*)
				(when (<= current-pos var)
					(incf n)))
			(goto-char (nth n *infoman-list-item-point*)))))

(defun infoman-goto-next-item ()
	"ڂֈړ"
	(interactive)
	(unless (or (= (buffer-lines) 1)
				(>= (point) (car *infoman-list-item-point*)))
		(let ((current-pos (point))
			  pos)
			(dolist (var *infoman-list-item-point*)
				(when (< current-pos var)
					(setf pos var)))
			(goto-char pos))))

(defun infoman-edit-item ()
	"ݍs̍ڕҏW"
	(interactive)
	(unless (= (buffer-lines) 1)
		(let ((item-num (infoman-get-position)))
			(infoman-draft-mode)
			(infoman-show-edit-content (nth item-num *infoman-list-item-value*) item-num))))

(defun infoman-view-mode ()
	"r[obt@쐬"
	(set-buffer (get-buffer-create *infoman-view-buffer-name*))
	(kill-all-local-variables)
	(setf mode-name "View")
	(setf buffer-mode 'infoman-view-mode)
	(use-keymap *infoman-view-mode-map*)
	(make-local-variable 'mode-line-format)
	(setf mode-line-format "%M")
	(make-local-variable 'kept-undo-information)
	(setf kept-undo-information nil)
	(make-local-variable 'need-not-save)
	(setf need-not-save t)
	(make-local-variable 'auto-save)
	(setf auto-save nil)
	(set-local-window-flags (selected-buffer) *infoman-view-buffer-flags* nil)
	(set-buffer-fold-width t)
	(setf buffer-read-only t)
	(run-hooks '*infoman-view-mode-hook*))
